<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <gender>Mid-term exam</gender>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <style>
    img{
        height: 150px;
        width: 150px;
    }
</style>
</head>
<body class="hold-transition sidebar-mini">
<!-- Site wrapper -->
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="index3.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Contact</a>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">DevCamp 120</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/LinhLT.jpeg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">LinhLT</a>
        </div>
      </div>

      <!-- SidebarSearch Form -->
      <div class="form-inline">
        <div class="input-group" data-widget="sidebar-search">
          <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
          <div class="input-group-append">
            <button class="btn btn-sidebar">
              <i class="fas fa-search fa-fw"></i>
            </button>
          </div>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="department.crud.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Department CRUD</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="employee.crud.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Employee CRUD</p>
                </a>
              </li>
            </ul>
          </li>
          
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Department - Employee CRUD</h1>
          </div>
          
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container">
        <h2 style="text-align: center;">Quản trị Nhân viên</h2>
        <div class="jumbotron container">
          <div class="row form-group">
          <div class="col-sm-3">
            <label for="code">Mã nhân viên</label>
          </div>
          <div class="col-sm-9">
            <input type="text" id="input-code" name="code" placeholder="Employee code"
            class="form-control">
          </div>
          </div>
          <div class="row form-group">
          <div class="col-sm-3">
            <label for="name">Tên nhân viên</label>
          </div>
          <div class="col-sm-9">
            <input type="text" id="input-name" name="name" placeholder="Employee name" class="form-control">
          </div>
          </div>
          <div class="row form-group">
            <div class="col-sm-3">
              <label for="level">Chức vụ</label>
            </div>
            <div class="col-sm-9">
              <input type="text" id="input-level" name="level" placeholder="Level" class="form-control">
            </div>
          </div>
          <div class="row form-group">
          <div class="col-sm-3">
            <label for="gender">Giới tính</label>
          </div>
          <div class="col-sm-9">
            <select type="text" id="select-gender" name="gender" placeholder="gender" class="form-control">
              <option>Nam</option>
              <option>Nữ</option>
            </select>
          </div>
          </div>
          <div class="row form-group">
          <div class="col-sm-3">
            <label for="dob">Ngày sinh</label>
          </div>
          <div class="col-sm-9">
            <input type="date" id="input-dob" name="dob" placeholder="Create Date" class="form-control">
          </div>
          </div>
          <div class="row form-group">
            <div class="col-sm-3">
              <label for="address">Địa chỉ</label>
            </div>
            <div class="col-sm-9">
              <input type="text" id="input-address" name="address" placeholder="Address" class="form-control">
            </div>
          </div>
          <div class="row form-group">
            <div class="col-sm-3">
              <label for="phone">Số điện thoại</label>
            </div>
            <div class="col-sm-9">
              <input type="text" id="input-phone" name="phone" placeholder="Level" class="form-control">
            </div>
          </div>
          <div class="row form group">
            <div class = "col-sm-3">
              <label for = "department">Tên phòng ban</label>
            </div>
            <div class = "col-sm-9">
              <select id="select-department" name="department" class = "form-control">
              </select>
            </div>
          </div>
          <div class = "row form-group">
          </div>
          <div class="row pull-right">
          <div class="col-sm-3">
          </div>
          <div class="col-sm-9">
            <div class ="row">
              <div class="col-sm-3">
                <button id="btn-update-employee" class="btn btn-info w-100"><i class="fas fa-edit"></i>&nbsp;Update</button>
              </div>
              <div class="col-sm-3">
                <button id="btn-delete-employee" class="btn btn-danger w-100"><i class="fas fa-trash"></i>&nbsp;Delete</button>
              </div>
              <div class="col-sm-3">
                <button id="btn-create-employee" class="btn btn-success w-100"><i class="fa fa-plus"></i>&nbsp;Add New</button>
              </div>
              <div class = "col-sm-3">
                <button id="btn-cancel" class="btn btn-secondary w-100">Cancel</button>
              </div>
            </div>
          </div>
          
          </div>
        </div>
        <table class="table table-bordered table-striped table-hover" id="employee-table">
          <thead>
            <tr>
              <th>Id</th>
              <th>Mã Nhân viên</th>
              <th>Tên Nhân viên</th>
              <th>Chức vụ</th>
              <th>Giới tính</th>
              <th>Ngày sinh</th>
              <th>Địa chỉ</th>
              <th>Số điện thoại</th>
            </tr>
        </table>
      </div>
    </section>
    <!-- /.content -->
  </div>
  <!-- Delete confirm modal -->
  <div>
    <div class="modal fade" tabindex="-1" id="delete-modal">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-gender" id="h5-modal-gender">Xác nhận xóa employee</h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <label>Bạn có chắc chắn muốn xóa employee này không?</label>
          </div>
          <div class="modal-footer">
            <button class="btn btn-danger" id="btn-confirm-delete">Xác nhận</button>
            <button class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
          </div>
        </div>
      </div>
    </div>
  </div>
  <!-- /.content-wrapper -->

  <footer class="main-footer">
    <div class="float-right d-none d-sm-block">
      <b>Version</b> 1.0.0
    </div>
    <strong>Copyright &copy; 2023 <a href="">DevCamp 120</a>.</strong> All rights reserved.
  </footer>

  <!-- Control Sidebar -->
  <aside class="control-sidebar control-sidebar-dark">
    <!-- Control sidebar content goes here -->
  </aside>
  <!-- /.control-sidebar -->
</div>
<!-- ./wrapper -->

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>
<script>
  "use strict";
/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
// Biến toàn cục để lưu trữ id employee đang đc update or delete. Mặc định = 0;
var gEmployeeId = 0;
const gBASE_URL = "http://localhost:8080/employee";
const gCONTENT_TYPE = "application/json;charset=UTF-8";
var gDepartmentSelectElement = $("#select-department");
var gEmployeeArr = [];
$(document).ready(function(){
  getAllDepartments();
	var table = $("#employee-table").DataTable({
		"columns": [
			{"data":"id"},
			{"data":"code"},
			{"data":"name"},
      {"data":"level"},
      {"data":"gender"},
			{"data":"dateOfBirth"},
			{"data":"address"},
      {"data":"phone"},
		]
	})
	$.ajax({
		url: gBASE_URL + "/all",
		type: "GET",
		dataType: "json",
		success: function(res){
			console.log(res);
      gEmployeeArr = res;
			table.clear();
			table.rows.add(res);
			table.draw();
		},
		error: function(err){
			console.log(err.responseText);
		}
	})
		
	/*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
	//Subtask 1- add click event to all rows
	$("#employee-table").on("click", "tr", function(){
		onRowClick(this);
	})
	//task 2 - Update employee: add event to save data button
	$("#btn-update-employee").on("click",function(){
		onUpdateButtonClick();
	});
	//task 3 - Create new employee
	$("#btn-create-employee").on("click",function(){
		onCreateButtonClick();
	});
	//task 4 - Delete employee selected
	$("#btn-delete-employee").on("click",function(){
		onDeleteButtonClick();
	});
	//task 5 - Cancel
	$("#btn-cancel").on("click",function(){
		onCancelBtnClick();
	});
  //gán sự kiện cho nút xác nhận xóa data trên modal
  $("#btn-confirm-delete").on("click",function(){
    onBtnConfirmDeleteEmployeeClick();
  });
  
	/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */ 
	//hàm xử lý sự kiện click row
	function onRowClick(paramRow){
		gEmployeeId = $(paramRow).find("td:eq(0)").html();
		console.log("Employee id of selected row: " + gEmployeeId);
		//lấy thông tin employee của row được click và hiển thị lên form
		var vEmployee = callApiGetEmployeeById(gEmployeeId);
	};
	
	//hàm xử lý sự kiện nút save data
	function onUpdateButtonClick(){
		//khai báo employee obj
		var vEmployeeObj = {
			code: "",
			name: "",
      level:"",
			gender:"",
      dateOfBirth: "",
      address: "",
      phone: ""
		}
		// B1: Thu thập dữ liệu
		getUpdateEmployeeData(vEmployeeObj);
		// B2: Validate update
		var vIsEmployeeValid = validateEmployeeData(vEmployeeObj);
    	if (vIsEmployeeValid){
			// B3: update employee
			$.ajax({
				url: gBASE_URL +"/update/"+ gEmployeeId,
				type: "PUT",
				contentType: gCONTENT_TYPE,
				data: JSON.stringify(vEmployeeObj),
				success: function(res){
					// B4: xử lý hiển thị
					handleUpdateEmployeeSuccess();
				},
				error: function(err){
					alert(err.responseText);
				}
			})
		}
	}
	
	//hàm xử lý sự kiện nút thêm employee
	function onCreateButtonClick(){
		//khai báo employee obj
		var vEmployeeObj = {
			code: "",
			name: "",
      level:"",
			gender:"",
      dateOfBirth: "",
      address: "",
      phone: "",
      department: -1
		}
		// B1: Thu thập dữ liệu
		getCreateEmployeeData(vEmployeeObj);
		// B2: Validate data
		var vIsEmployeeValid = validateEmployeeData(vEmployeeObj);
    	if (vIsEmployeeValid){
			// B3: create employee
			$.ajax({
				url: gBASE_URL + "/create/" + vEmployeeObj.department,
				type: "POST",
				contentType: gCONTENT_TYPE,
				data: JSON.stringify(vEmployeeObj),
				success: function(res){
					// B4: xử lý hiển thị
					handleCreateEmployeeSuccess();
				},
				error: function(err){
					alert(err.responseText);
				}
			})
		}
	}
	//hàm xử lý sự kiện nút xóa employee được chọn và hiển thị trên form
	function onDeleteButtonClick(){
    $("#delete-modal").modal("show");
	}
  //hàm xử lý sự kiện xác nhận xóa employee
  function onBtnConfirmDeleteEmployeeClick(){
    "use strict";
    //gọi API xóa employee
    ajaxDeleteEmployee(gEmployeeId);
  }
  
	function onCancelBtnClick(){
    $("#input-code").val("");
		$("#input-name").val("");
    $("#input-level").val("");  
		$("#select-gender").val(""); 
		$("#input-dob").val("");
    $("#input-address").val(""); 
    $("#input-phone").val("");  
	}
	/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
	//hàm load lại datatable
  function loadDataToTable(){
    $.ajax({
      url: gBASE_URL + "/all",
      type: "GET",
      dataType: "json",
      success: function(res){
        console.log(res);
        table.clear();
        table.rows.add(res);
        table.draw();
      },
      error: function(err){
        console.log(err.responseText);
      }
    })
  }
  //load data to department select
  function getAllDepartments(){
    $.ajax({
      url: "http://localhost:8080/department/all",
      method: "GET",
      success: function(pObjRes) {
        console.log(pObjRes);
        loadDataToDepartmentSelect(pObjRes);
      },
      error: function(paramErr) {
        console.log(paramErr.responseText);
      }
    });
    //load data to department select
    function loadDataToDepartmentSelect(pDepartmentList) {
      for (let i = 0; i < pDepartmentList.length; i++) {
        var bDepartmentOption = $("<option/>");
        bDepartmentOption.prop("value", pDepartmentList[i].id);
        bDepartmentOption.prop("text", pDepartmentList[i].name);
        gDepartmentSelectElement.append(bDepartmentOption);
      };
    }
  }
  //hàm gọi API lấy thông tin employee của dòng được chọn
	function callApiGetEmployeeById(paramId){
		$.ajax({
			url: gBASE_URL +"/detail/"+ paramId,
			type: "GET",
			dataType: "json",
			success: function(res){
				console.log(res);
				displayEmployeeData(res);
			},
			error: function(err){
				console.log(err.responseText);
			}
		})
	}
	//hàm hiển thị thông tin employee của dòng được click
	function displayEmployeeData(paramEmployee){
		$("#input-code").val(paramEmployee.code);
		$("#input-name").val(paramEmployee.name);
    $("#input-level").val(paramEmployee.level);  
		$("#select-gender").val(paramEmployee.gender); 
		$("#input-dob").val(paramEmployee.dateOfBirth);
    $("#input-address").val(paramEmployee.address); 
    $("#input-phone").val(paramEmployee.phone);  
	}
	// hàm thu thập dữ liệu để update employee
	function getUpdateEmployeeData(paramEmployeeObj) {
    paramEmployeeObj.id = gEmployeeId;
		paramEmployeeObj.code =$("#input-code").val().trim();
		paramEmployeeObj.name = $("#input-name").val().trim(); 
    paramEmployeeObj.level = $("#input-level").val().trim(); 
		paramEmployeeObj.gender = $("#select-gender").val();
    paramEmployeeObj.dateOfBirth = $("#input-dob").val();
    paramEmployeeObj.address = $("#input-address").val().trim();
    paramEmployeeObj.phone = $("#input-phone").val().trim(); 
	}
  // hàm thu thập dữ liệu để create employee
	function getCreateEmployeeData(paramEmployeeObj) {
		paramEmployeeObj.code =$("#input-code").val().trim();
		paramEmployeeObj.name = $("#input-name").val().trim(); 
    paramEmployeeObj.level = $("#input-level").val().trim(); 
		paramEmployeeObj.gender = $("#select-gender").val().trim();
    paramEmployeeObj.dateOfBirth = $("#input-dob").val();
    paramEmployeeObj.address = $("#input-address").val().trim();
    paramEmployeeObj.phone = $("#input-phone").val().trim(); 
    paramEmployeeObj.department = $("#select-department").val(); 
	}

	// hàm validate data
	function validateEmployeeData(paramEmployeeObj) {
		if (paramEmployeeObj.code === "") {
      alert("Cần nhập mã employee");
      return false;
		}
    
		if (paramEmployeeObj.name === "") {
      alert("Cần nhập tên employee");
      return false;
		}

    if (paramEmployeeObj.level === "") {
      alert("Cần nhập chức vụ employee");
      return false;
		}

		if (paramEmployeeObj.dateOfBirth === "") {
      alert("Cần nhập ngày sinh employee");
      return false;
		}
    if (paramEmployeeObj.address === "") {
      alert("Cần nhập địa chỉ employee");
      return false;
		}
    if (paramEmployeeObj.phone === "") {
      alert("Cần nhập số điện thoại employee");
      return false;
		}

		return true;
	}
	
	//hiển thị cập nhật employee thành công
	function handleUpdateEmployeeSuccess(){
		alert("Sửa employee có id: " + gEmployeeId + " thành công!");
    loadDataToTable();
	};
	//hiển thị thêm employee thành công
	function handleCreateEmployeeSuccess(){
		alert("Thêm employee thành công!");
    loadDataToTable();
	};
  //API xóa employee
  function ajaxDeleteEmployee(paramId){
    //b1: thu thập dữ liệu
    //b2: validate
    //b3: thực hiện xóa - gọi API
    $.ajax({
      url: gBASE_URL +"/delete/"+ paramId,
      type: "DELETE",
      success: function(paramRes) {
        handleDeleteEmployeeSuccess();
      },
      error: function(paramErr) {
        alert("Xóa employee không thành công");
      }
    });
  };
  
	//hiển thị xóa employee thành công
	function handleDeleteEmployeeSuccess(){
		alert("Xóa employee có id: " + gEmployeeId + " thành công!");
    loadDataToTable();
    //ẩn modal
    $("#delete-modal").modal("hide");
	};
})
</script>
</body>
</html>
